﻿class Engine {
	var xml:XML;
	var currentLocation:Location;
	var errorPickUp:String;
	var errorUse:String;
	var errorUseWith:String;
	var errorOpen:String;
	var errorClose:String;
	
	function Engine() {
		System.useCodepage = true;
	}
	
	function loadGame(file:String):Void {
		var gameEngine = this;
		var xml = new XML();
		xml.ignoreWhite = true;
		xml.onLoad = function(success):Void {
			if (success) {
				var xmlStory = this.firstChild;
				var xmlConfig = xmlStory.firstChild;
				var startLocation:Location = xmlConfig.childNodes[0].firstChild.nodeValue;
				gameEngine.errorPickUp = xmlConfig.childNodes[1].firstChild.nodeValue;
				gameEngine.errorUse = xmlConfig.childNodes[2].firstChild.nodeValue;
				gameEngine.errorUseWith = xmlConfig.childNodes[3].firstChild.nodeValue;
				gameEngine.errorOpen = xmlConfig.childNodes[4].firstChild.nodeValue;
				gameEngine.errorClose = xmlConfig.childNodes[5].firstChild.nodeValue;
				
				var xmlLocations = xmlStory.firstChild.nextSibling;
				
				for(var loc = 0; loc < xmlLocations.childNodes.length; loc++) {
					
					var xmlLocation = xmlLocations.childNodes[loc];
					var id:String = xmlLocation.attributes['id'];
					var name:String = xmlLocation.attributes['name'];
					var backgroundPicture = xmlLocation.attributes['background'];
					var description:String = gameEngine.trim(xmlLocation.firstChild.firstChild.nodeValue);
					var location = new Location(id, name, description);
					location.setBackground(backgroundPicture);
					
					for(var hboxs = 0; hboxs < xmlLocation.firstChild.nextSibling.childNodes.length; hboxs++) {
						var xmlHitbox = xmlLocation.firstChild.nextSibling.childNodes[hboxs];
						var id:String = xmlHitbox.attributes['id'];
						var x:Number = xmlHitbox.attributes['x'];
						var y:Number = xmlHitbox.attributes['y'];
						var width:Number = xmlHitbox.attributes['width'];
						var height:Number = xmlHitbox.attributes['height'];
						var name:String = gameEngine.trim(xmlHitbox.firstChild.firstChild.nodeValue);
						var description:String = gameEngine.trim(xmlHitbox.firstChild.nextSibling.firstChild.nodeValue);
						var hitBox = new HitBox(x, y, width, height, name, id);
						hitBox.description = description;
						hitBox.eventClick = xmlHitbox.attributes['eventClick'];
						hitBox.eventUse = xmlHitbox.attributes['eventUse'];
						hitBox.eventUseWith = xmlHitbox.attributes['eventUseWith'];
						hitBox.eventPickUp = xmlHitbox.attributes['eventPickUp'];
						hitBox.eventOpen = xmlHitbox.attributes['eventOpen'];
						hitBox.eventClose = xmlHitbox.attributes['eventClose'];
						hitBox.eventLookAt = xmlHitbox.attributes['eventLookAt'];
						hitBox.visible = (xmlHitbox.attributes['visible'] == 1 ? true : false);
						hitBox.active = (xmlHitbox.attributes['active'] == 1 ? true : false);
						hitBox.location = location;
						location.addHitBox(hitBox);
					}
					
					for(var witems = 0; witems < xmlLocation.firstChild.nextSibling.nextSibling.childNodes.length; witems++) {
						var xmlWorldItem = xmlLocation.firstChild.nextSibling.nextSibling.childNodes[witems];
						var id:String = xmlWorldItem.attributes['id'];
						var x:Number = xmlWorldItem.attributes['x'];
						var y:Number = xmlWorldItem.attributes['y'];
						var picture:String = xmlWorldItem.attributes['picture'];
						var inventory:String = xmlWorldItem.attributes['inventory'];
						var name:String = gameEngine.trim(xmlWorldItem.firstChild.firstChild.nodeValue);
						var description:String = gameEngine.trim(xmlWorldItem.firstChild.nextSibling.firstChild.nodeValue);
						var wItem = new WorldItem(x, y, picture, inventory, name, id, description);
						wItem.visible = (xmlWorldItem.attributes['visible'] == 1) ? true : false;
						wItem.pickUpPossible = (xmlWorldItem.attributes['take'] == 1) ? true : false;
						wItem.active = (xmlWorldItem.attributes['active'] == 1) ? true : false;
						wItem.eventClick = xmlWorldItem.attributes['eventClick'];
						wItem.eventUse = xmlWorldItem.attributes['eventUse'];
						wItem.eventUseWith = xmlWorldItem.attributes['eventUseWith'];
						wItem.eventPickUp = xmlWorldItem.attributes['eventPickUp'];
						wItem.eventOpen = xmlWorldItem.attributes['eventOpen'];
						wItem.eventClose = xmlWorldItem.attributes['eventClose'];
						wItem.eventLookAt = xmlWorldItem.attributes['eventLookAt'];
						wItem.location = location;
						location.addWorldItem(wItem);
					}
					location.eventsXML = xmlLocation.firstChild.nextSibling.nextSibling.nextSibling;
					
					_global.gameInterface.addLocation(location);
				}
				_global.gameInterface.setUpLocation(startLocation);
			}
		};
		xml.load(file);		
	}
	
	function rtrim(matter:String):String {
		if ((matter.length>1) || (matter.length == 1 && matter.charCodeAt(0)>32 && matter.charCodeAt(0)<255)) {
			var i = matter.length-1;
			while (i>=0 && (matter.charCodeAt(i)<=32 || matter.charCodeAt(i)>=255)) {
				i--;
			}
			matter = matter.substring(0, i+1);
		} else {
			matter = "";
		}
		return matter;
	}

	function ltrim(matter:String):String {
		if ((matter.length>1) || (matter.length == 1 && matter.charCodeAt(0)>32 && matter.charCodeAt(0)<255)) {
			var i = 0;
			while (i<matter.length && (matter.charCodeAt(i)<=32 || matter.charCodeAt(i)>=255)) {
				i++;
			}
			matter = matter.substring(i);
		} else {
			matter = "";
		}
		return matter;
	}
	
	function trim(matter:String):String {
		return this.ltrim(this.rtrim(matter));
	}
}