﻿class EventHandler {
	
	function handleEvent(eventTodo:String, eventItem):Void {
		// ============================
		// Befehl: EVENT
		// ============================
		if(eventTodo != undefined) {
			var xmlEvents = eventItem.location.getLocationEventAsXML(eventTodo);
			for(var i:Number=0; i<xmlEvents.childNodes.length; i++) {
				var eventName:String = xmlEvents.childNodes[i].nodeName;
				var eventObject:String = xmlEvents.childNodes[i].firstChild.nodeValue;
				var loc:Location = _global.gameInterface.getLocationById(xmlEvents.childNodes[i].attributes['location']);
			// ============================
			// Befehl: addInventoryItem
			// ============================
				if(eventName.toLowerCase() == "addinventoryitem") {
					var wItem:WorldItem = loc.getWorldItemById(eventObject);
					wItem.toggleVisibility();
					wItem.markAsPickedUp();
					var iItem = new InventoryItem(wItem.name, wItem.id, wItem.inventoryPicture, wItem.description);
					iItem.alreadyPickedUp = wItem.alreadyPickedUp;
					iItem.location = wItem.location;
					iItem.eventClick = wItem.eventClick;
					iItem.eventUse = wItem.eventUse;
					iItem.eventUseWith = wItem.eventUseWith;
					iItem.eventOpen = wItem.eventOpen;
					iItem.eventClose = wItem.eventClose;
					iItem.eventPickUp = wItem.eventPickUp;
					iItem.eventLookAt = wItem.eventLookAt;
					_global.gameInventory.addInventoryItem(iItem);
					_global.gameInventory.setup();
					_global.gameMouse.ready();
			// ============================
			// Befehl: goto
			// ============================
				} else if(eventName.toLowerCase() == "goto") {
					_global.gameInterface.setUpLocation(eventObject);
			// ============================
			// Befehl: playSound
			// ============================
				} else if (eventName.toLowerCase() == "playsound") {
					//var vSound = xmlEvents.childNodes[i].attributes['item'];
					_global.gameInterface.playSound(eventObject);
			// ============================
			// Befehl: print
			// ============================
				} else if (eventName.toLowerCase() == "print") {
					if(eventObject != undefined && eventObject.length > 0) {
						_global.gameMessageBox.text = eventObject + "\n\n" + _global.gameMessageBox.text;
					}
			// ============================
			// Befehl: removeHitBox
			// ============================
				} else if (eventName.toLowerCase() == "removehitbox") {
					loc.removeHitBox(eventObject);
			// ============================
			// Befehl: removeInventoryItem
			// ============================
				} else if (eventName.toLowerCase() == "removeinventoryitem") {
					_global.gameInventory.clear();						
					_global.gameInventory.removeInventoryItemById(eventObject);
					_global.gameInventory.setup();
			// ============================
			// Befehl: removeWorldItem
			// ============================
				} else if (eventName.toLowerCase() == "removeworlditem") {
					loc.removeWorldItem(eventObject);
			// ============================
			// Befehl: replaceInventoryItem
			// ============================
				} else if(eventName.toLowerCase() == "replaceinventoryitem") {
					var oldLoc:Location = _global.gameInterface.getLocationById(xmlEvents.childNodes[i].attributes['oldLocation']);
					var oldItem:InventoryItem = _global.gameInventory.getInventoryItemById(xmlEvents.childNodes[i].attributes['oldItem']);
					var wItem:WorldItem = loc.getWorldItemById(eventObject);
					wItem.markAsPickedUp();
					var iItem = new InventoryItem(wItem.name, wItem.id, wItem.inventoryPicture, wItem.description);
					iItem.alreadyPickedUp = wItem.alreadyPickedUp;
					iItem.location = wItem.location;
					iItem.eventClick = wItem.eventClick;
					iItem.eventUse = wItem.eventUse;
					iItem.eventUseWith = wItem.eventUseWith;
					iItem.eventOpen = wItem.eventOpen;
					iItem.eventClose = wItem.eventClose;
					iItem.eventPickUp = wItem.eventPickUp;
					iItem.eventLookAt = wItem.eventLookAt;
					_global.gameInventory.replaceInventoryItem(oldItem, iItem);
					_global.gameInventory.setup();
					_global.gameMouse.ready();
			// ============================
			// Befehl: requireHitBoxActive
			// ============================
				} else if (eventName.toLowerCase() == "requirehitboxactive") {
					var hBox:HitBox = loc.getHitBoxById(eventObject);
					if(!hBox.active) {
						if(xmlEvents.childNodes[i].attributes['falseMSG'] != undefined) {
							_global.gameMessageBox.text = xmlEvents.childNodes[i].attributes['falseMSG'] + "\n\n" + _global.gameMessageBox.text;
						}
						_global.gameMouse.ready();
						break;
					}
			// ============================
			// Befehl: requireHitBoxInactive
			// ============================
				} else if (eventName.toLowerCase() == "requirehitboxinactive") {
					var hBox:HitBox = loc.getHitBoxById(eventObject);
					if(hBox.active) {
						if(xmlEvents.childNodes[i].attributes['falseMSG'] != undefined) {
							_global.gameMessageBox.text = xmlEvents.childNodes[i].attributes['falseMSG'] + "\n\n" + _global.gameMessageBox.text;
						}
						_global.gameMouse.ready();
						break;
					}
			// ============================
			// Befehl: requireInventoryItem
			// ============================
				} else if (eventName.toLowerCase() == "requireinventoryitem") {
					var invItem = _global.gameInventory.getInventoryItemById(eventObject);
					if(invItem == undefined) {
						if(xmlEvents.childNodes[i].attributes['falseMSG'] != undefined) {
							_global.gameMessageBox.text = xmlEvents.childNodes[i].attributes['falseMSG'] + "\n\n" + _global.gameMessageBox.text;
						}
						_global.gameMouse.ready();
						break;
					}
			// ============================
			// Befehl: requireInventoryItemUseWith
			// ============================
				} else if (eventName.toLowerCase() == "requireinventoryitemusewith") {
					var wItem:WorldItem = _global.gameMouse.usingItem;
					if((wItem == null || wItem.id != eventObject)) {
						_global.gameMouse.usingItem = undefined;
						if(xmlEvents.childNodes[i].attributes['falseMSG'] != undefined) {
							_global.gameMessageBox.text = xmlEvents.childNodes[i].attributes['falseMSG'] + "\n\n" + _global.gameMessageBox.text;
						}
						_global.gameMouse.ready();
						break;
					} else {
						 if(wItem.alreadyPickedUp == false) {
							_global.gameMouse.usingItem = undefined;
							if(xmlEvents.childNodes[i].attributes['falseMSG'] != undefined) {
								_global.gameMessageBox.text = xmlEvents.childNodes[i].attributes['falseMSG'] + "\n\n" + _global.gameMessageBox.text;
							}
							_global.gameMouse.ready();
							break;
						 }
					}
					_global.gameMouse.ready();
			// ============================
			// Befehl: requireWorldItemActive
			// ============================
				} else if (eventName.toLowerCase() == "requireworlditemactive") {
					var wItem:WorldItem = loc.getWorldItemById(eventObject);
					if(!wItem.active) {
						if(xmlEvents.childNodes[i].attributes['falseMSG'] != undefined) {
							_global.gameMessageBox.text = xmlEvents.childNodes[i].attributes['falseMSG'] + "\n\n" + _global.gameMessageBox.text;
						}
						_global.gameMouse.ready();
						break;
					}
			// ============================
			// Befehl: requireWorldItemClose
			// ============================
				} else if (eventName.toLowerCase() == "requireworlditemclose") {
					var wItem:WorldItem = loc.getWorldItemById(eventObject);
					if(wItem.isOpen) {
						if(xmlEvents.childNodes[i].attributes['falseMSG'] != undefined) {
							_global.gameMessageBox.text = xmlEvents.childNodes[i].attributes['falseMSG'] + "\n\n" + _global.gameMessageBox.text;
						}
						_global.gameMouse.ready();
						break;
					}
			// ============================
			// Befehl: requireWorldItemInactive
			// ============================
				} else if (eventName.toLowerCase() == "requireworlditeminactive") {
					var wItem:WorldItem = loc.getWorldItemById(eventObject);
					if(wItem.active) {
						if(xmlEvents.childNodes[i].attributes['falseMSG'] != undefined) {
							_global.gameMessageBox.text = xmlEvents.childNodes[i].attributes['falseMSG'] + "\n\n" + _global.gameMessageBox.text;
						}
						_global.gameMouse.ready();
						break;
					}
			// ============================
			// Befehl: requireWorldItemOpen
			// ============================
				} else if (eventName.toLowerCase() == "requireworlditemopen") {
					var wItem:WorldItem = loc.getWorldItemById(eventObject);
					if(!wItem.isOpen) {
						if(xmlEvents.childNodes[i].attributes['falseMSG'] != undefined) {
							_global.gameMessageBox.text = xmlEvents.childNodes[i].attributes['falseMSG'] + "\n\n" + _global.gameMessageBox.text;
						}
						_global.gameMouse.ready();
						break;
					}
			// ============================
			// Befehl: toggleHitBoxActive
			// ============================
				} else if (eventName.toLowerCase() == "togglehitboxactive") {
					var hBox:HitBox = loc.getHitBoxById(eventObject);
					hBox.toggleActive((xmlEvents.childNodes[i].attributes['newValue']) != undefined ? (xmlEvents.childNodes[i].attributes['newValue'].toLowerCase() == "1" ? true : false) : undefined);
			// ============================
			// Befehl: toggleHitBoxVisible
			// ============================
				} else if (eventName.toLowerCase() == "togglehitboxvisible") {
					var hBox:HitBox = loc.getHitBoxById(eventObject);
					hBox.toggleVisibility((xmlEvents.childNodes[i].attributes['newValue']) != undefined ? (xmlEvents.childNodes[i].attributes['newValue'].toLowerCase() == "1" ? true : false) : undefined);
			// ============================
			// Befehl: toggleWorldItemActive
			// ============================
				} else if (eventName.toLowerCase() == "toggleworlditemactive") {
					var wItem:WorldItem = loc.getWorldItemById(eventObject);
					wItem.toggleActive((xmlEvents.childNodes[i].attributes['newValue']) != undefined ? (xmlEvents.childNodes[i].attributes['newValue'].toLowerCase() == "1" ? true : false) : undefined);
			// ============================
			// Befehl: toggleWorldItemOpen
			// ============================
				} else if (eventName.toLowerCase() == "toggleworlditemopen") {
					var wItem:WorldItem = loc.getWorldItemById(eventObject);
					wItem.toggleOpen((xmlEvents.childNodes[i].attributes['newValue']) != undefined ? (xmlEvents.childNodes[i].attributes['newValue'].toLowerCase() == "1" ? true : false) : undefined);
			// ============================
			// Befehl: toggleWorldItemVisible
			// ============================
				} else if (eventName.toLowerCase() == "toggleworlditemvisible") {
					var wItem:WorldItem = loc.getWorldItemById(eventObject);
					wItem.toggleVisibility((xmlEvents.childNodes[i].attributes['newValue']) != undefined ? (xmlEvents.childNodes[i].attributes['newValue'].toLowerCase() == "true" ? true : false) : undefined);
				}
			}
		// ============================
		// Kein EVENT gefunden
		// ============================
		} else {
			// ============================
			// WORLDITEM
			// ============================
			if(eventItem._isWorldItem) {
				if(_global.gameMouse.isPickingUp) {
					if(eventItem.pickUpPossible && !eventItem.alreadyPickedUp) {
						eventItem.toggleVisibility()
						eventItem.markAsPickedUp();
						var iItem = new InventoryItem(eventItem.name, eventItem.id, eventItem.inventoryPicture, eventItem.description);
						iItem.alreadyPickedUp = eventItem.alreadyPickedUp;
						iItem.location = eventItem.location;
						iItem.eventClick = eventItem.eventClick;
						iItem.eventUse = eventItem.eventUse;
						iItem.eventUseWith = eventItem.eventUseWith;
						iItem.eventOpen = eventItem.eventOpen;
						iItem.eventClose = eventItem.eventClose;
						iItem.eventPickUp = eventItem.eventPickUp;
						iItem.eventLookAt = eventItem.eventLookAt;
						_global.gameInventory.addInventoryItem(iItem);
						_global.gameInventory.setup();
						_global.gameMessageBox.text = eventItem.name + " aufgehoben!" + "\n\n" + _global.gameMessageBox.text;
						_global.gameMouse.ready();
					}
				} else if (_global.gameMouse.isUsingWith) {
					if(_global.gameMouse.usingItem == undefined) {
						_global.gameMouse.usingItem = eventItem;
					} else {
						_global.gameMouse.usingItem = undefined;
						_global.gameMessageBox.text = _global.gameEngine.errorUseWith + "\n\n" + _global.gameMessageBox.text;
						_global.gameMouse.ready();
					}
				} else if (_global.gameMouse.isUsing) {
					_global.gameMessageBox.text = _global.gameEngine.errorUse + "\n\n" + _global.gameMessageBox.text;
					_global.gameMouse.ready();
				} else if (_global.gameMouse.isOpening) {
					_global.gameMessageBox.text = _global.gameEngine.errorOpen + "\n\n" + _global.gameMessageBox.text;
					_global.gameMouse.ready();
				} else if (_global.gameMouse.isClosing) {
					_global.gameMessageBox.text = _global.gameEngine.errorClose + "\n\n" + _global.gameMessageBox.text;
					_global.gameMouse.ready();
				} else if (_global.gameMouse.isLookingAt || _global.gameMouse.isReady) {
					if(eventItem.description != undefined && eventItem.description.length > 0) {
						_global.gameMessageBox.text = eventItem.description + "\n\n" + _global.gameMessageBox.text;
						_global.gameMouse.ready();
					}
				}
			// ============================
			// HITBOX
			// ============================
			} else if (eventItem._isHitBox) {
				if(_global.gameMouse.isPickingUp) {
					_global.gameMessageBox.text = _global.gameEngine.errorPickUp + "\n\n" + _global.gameMessageBox.text;
					_global.gameMouse.ready();
				} else if (_global.gameMouse.isUsingWith) {
					_global.gameMessageBox.text = _global.gameEngine.errorUseWith + "\n\n" + _global.gameMessageBox.text;
					_global.gameMouse.ready();
				} else if (_global.gameMouse.isUsing) {
					_global.gameMessageBox.text = _global.gameEngine.errorUse + "\n\n" + _global.gameMessageBox.text;
					_global.gameMouse.ready();
				} else if (_global.gameMouse.isOpening) {
					_global.gameMessageBox.text = _global.gameEngine.errorOpen + "\n\n" + _global.gameMessageBox.text;
					_global.gameMouse.ready();
				} else if (_global.gameMouse.isClosing) {
					_global.gameMessageBox.text = _global.gameEngine.errorClose + "\n\n" + _global.gameMessageBox.text;
					_global.gameMouse.ready();
				} else if (_global.gameMouse.isLookingAt) {
					if(eventItem.description != undefined && eventItem.description.length > 0) {
						_global.gameMessageBox.text = eventItem.description + "\n\n" + _global.gameMessageBox.text;
						_global.gameMouse.ready();
					}
				}
			// ============================
			// INVENTORYITEM
			// ============================
			} else if (eventItem._isInventoryItem) {
				if (_global.gameMouse.isUsingWith) {
					if(_global.gameMouse.usingItem == undefined) {
						_global.gameMouse.usingItem = eventItem;
					} else {
						_global.gameMouse.usingItem = undefined;
						_global.gameMessageBox.text = _global.gameEngine.errorUseWith + "\n\n" + _global.gameMessageBox.text;
						_global.gameMouse.ready();
					}
				} else if (_global.gameMouse.isUsing) {
					_global.gameMessageBox.text = _global.gameEngine.errorUseWith + "\n\n" + _global.gameMessageBox.text;
					_global.gameMouse.ready();
				} else if (_global.gameMouse.isOpening) {
					_global.gameMessageBox.text = _global.gameEngine.errorOpen + "\n\n" + _global.gameMessageBox.text;
					_global.gameMouse.ready();
				} else if (_global.gameMouse.isClosing) {
					_global.gameMessageBox.text = _global.gameEngine.errorClose + "\n\n" + _global.gameMessageBox.text;
					_global.gameMouse.ready();
				} else if (_global.gameMouse.isLookingAt) {
					if(eventItem.description != undefined && eventItem.description.length > 0) {
						_global.gameMessageBox.text = eventItem.description + "\n\n" + _global.gameMessageBox.text;
						_global.gameMouse.ready();
					}
				} else if (_global.gameMouse.isReady) {
					var scrollCursor = _root.cursor.createEmptyMovieClip("drag", 0);
					var scrollGraphic = scrollCursor.createEmptyMovieClip("tmp_drag", 1);
					var my_mcl = new MovieClipLoader();
					var myListener = new Object();
					myListener.onLoadInit = function(target_mc) {
						scrollGraphic._x -= scrollGraphic._width / 2;				
						scrollGraphic._y -= scrollGraphic._height / 2;				
						//Mouse.hide();
						_global.gameMouse.drag();
						_global.gameMouse.isUsingWith = true;
						_global.gameMouse.usingItem = eventItem;
						scrollCursor.startDrag(true);
					};
					my_mcl.addListener(myListener);
					my_mcl.loadClip(eventItem.picture, scrollGraphic);
				}
			}
		}
		if(_global.gameMouse.usingItem == undefined) {
			_global.gameMouse.ready();
		}
	}
}