﻿class Interface {
	var locations:Vector;
	var interfaceSetup:Function;
	var locationSetup:Function;
	
	var background:MovieClip;
	var backgroundMoving:Boolean = false;
	var scrollBackgroundId:Number;
	var scrollCursor:MovieClip;
	var scrollGraphic:MovieClip;
	
	var showInterfaceID;
	
	var itemBar:MovieClip;
	var moveItemBarId:Number;
	var itemBarMoving:Boolean = false;
	
	var actionBox:MovieClip;
	var moveActionBoxId:Number;
	var actionBoxMoving:Boolean = false;
	var actionBoxVisible:Boolean = false;
	
	var messageBox:MovieClip;
	var moveMessageBoxId:Number;
	var messageBoxMoving:Boolean = false;
	var messageBoxVisible:Boolean = false;
	
	var messageBoxTextScrolling:Boolean = false;
	var scrollMessageBoxTextId:Number;
	
	function Interface(actionBox:MovieClip, messageBox:MovieClip, itemBar:MovieClip) {
		this.locations = new Vector(10, 10);
		this.actionBox = actionBox;
		this.messageBox = messageBox;
		this.itemBar = itemBar;
		this.background = _root.background;
	}
	
	function addLocation(location:Location) {
		this.locations.addElement(location);
	}
	
	function setUpLocation(id:String) {
		this.showInterface(false);
		for(var i:Number=0; i<this.locations.size(); i++) {
			var location:Location = this.locations.get(i);
			if(location.id == id)
				break;
		}
		this.setUpLocationIntern(location);
	}
	
	private function setUpLocationIntern(location:Location) {
		location.backgroundComplete = this.setUpWorldItems(location);
		location.setUpBackground();
	}

	function setUpWorldItems(location:Location) {
		location.worldItemsComplete = this.setUpHitBoxes(location);
		location.setUpWorldItems();
	}

	function setUpHitBoxes(location:Location) {
		var iface = this;
		location.hitBoxesComplete = function():Void {
			iface.showInterfaceID = setInterval(iface, "showInterface", 1, true, location);
		}
		location.setUpHitBoxes();
	}
	
	function showInterface(show:Boolean, location:Location):Void {
		clearInterval(this.showInterfaceID);
		_global.gameInfoBox.text = "";
		if(location.description != undefined && location.description.length > 0 ) {
			_global.gameMessageBox.text = location.description + "\n\n" + _global.gameMessageBox.text;
		}
		this.interfaceSetup;
		_global.gameEngine.currentLocation = location;
		_root.displayInterface._visible = !show;
	}
	
	function stopDragging():Void {
		if(_global.gameMouse.isDragging) {
			_root.cursor.drag.removeMovieClip();
			_root.cursor.removeMovieClip();
			Mouse.show();
			stopDrag();
		}
	}
	
	function playSound(file:String):Void {
		var vSound = _root.sounds.createEmptyMovieClip("temp_sound", _root.sounds.getNextHighestDepth());
		vSound.loadMovie(file);
	}
	
	function getLocationById(id:String) {
		for(var i:Number = 0; i<this.locations.size(); i++) {
			var loc:Location = this.locations.get(i);
			if(loc.id == id) {
				return loc;
			}
		}
		return null;
	}
	
/**  
* ===========================================================================
* BACKGROUND
* ===========================================================================
**/
	function scrollBackground(dir:String):Void {
		var showScrollCursor:Boolean = true;
		clearInterval(this.scrollBackgroundId);
		if(!_global.gameMouse.isDragging) {
			if(!this.backgroundMoving) {
				if(dir == "up" || dir == "down") {
					if(this.background._height <= 400) 
						showScrollCursor = false;
				} else {
					if(this.background._width <= 640) 
						showScrollCursor = false;
				}
				if(showScrollCursor) {
					this.scrollCursor = _root.cursor.createEmptyMovieClip("scroll",0);
					this.scrollGraphic = this.scrollCursor.createEmptyMovieClip("tmp_scroll", 1);
					scrollGraphic.loadMovie("img/layout/scroll_"+dir+".swf");
					this.scrollCursor.startDrag(true);
					_global.gameMouse.isScrolling = true;
					Mouse.hide();
				}
			}
			
			if(dir == "up") {
				if(this.background._y < 77) {
					this.backgroundMoving = true;
					this.background._y += 5;
					_root.hitBoxes._y += 5;
					_root.worldItems._y += 5;
					this.scrollBackgroundId = setInterval(this, "scrollBackground", 10, dir);
				} else {
					this.background._y = 80;
					_root.hitBoxes._y = 80;
					_root.worldItems._y = 80;
					this.backgroundMoving = false;
				}
			} else if (dir == "down") {
				if((this.background._y + this.background._height) > 483) {
					this.backgroundMoving = true;
					this.background._y -= 5;
					_root.hitBoxes._y -= 5;
					_root.worldItems._y -= 5;
					this.scrollBackgroundId = setInterval(this, "scrollBackground", 10, dir);
				} else {
					this.background._y = 480 - this.background._height;
					_root.hitBoxes._y = 480 - this.background._height;
					_root.worldItems._y = 480 - this.background._height;
					this.backgroundMoving = false;
				}
			} else if (dir == "left") {
				if(this.background._x < -3) {
					this.backgroundMoving = true;
					this.background._x += 5;
					_root.hitBoxes._x += 5;
					_root.worldItems._x += 5;
					this.scrollBackgroundId = setInterval(this, "scrollBackground", 10, dir);
				} else {
					this.background._x = 0;
					_root.hitBoxes._x = 0;
					_root.worldItems._x = 0;
					this.backgroundMoving = false;
				}
			} else {
				if((this.background._x + this.background._width) > 643) {
					this.backgroundMoving = true;
					this.background._x -= 5;
					_root.hitBoxes._x -= 5;
					_root.worldItems._x -= 5;
					this.scrollBackgroundId = setInterval(this, "scrollBackground", 10, dir);
				} else {
					this.background._x = 640 - this.background._width;
					_root.hitBoxes._x = 640 - this.background._width;
					_root.worldItems._x = 640 - this.background._width;
					this.backgroundMoving = false;
				}
			}
		}
	}
	
	function stopBackgroundScroll():Void {
		if(_global.gameMouse.isScrolling) {
			stopDrag();
			this.scrollGraphic.removeMovieClip();
			clearInterval(this.scrollBackgroundId);
			this.backgroundMoving = false;
			_global.gameMouse.isScrolling = false;
			Mouse.show();
		}
	}
	
/** 
* ===========================================================================
* ITEMBAR BOX
* ===========================================================================
**/	function isItemBarMoving() {
		return this.itemBarMoving;
	}
	
	function moveItemBar(dir:String) {
		clearInterval(this.moveItemBarId);
		if(dir == "left") {
			if(this.itemBar._x < 46) {
				this.itemBar._x += 3;
				this.itemBarMoving = true;
				this.moveItemBarId = setInterval(this, "moveItemBar", 10, dir);
			} else {
				this.itemBar._x = 46;
				this.itemBarMoving = false;
			}
		} else {
			if(this.itemBar._width > 548) {
				if(this.itemBar._x > 584 - this.itemBar._width) {
					this.itemBar._x -= 3;
					this.itemBarMoving = true;
					this.moveItemBarId = setInterval(this, "moveItemBar", 10, dir);
				} else {
					this.itemBar._x = 584 - this.itemBar._width;
					this.itemBarMoving = false;
				}
			} else {
				this.itemBarMoving = false;
			}
		}
	}
	
	function stopItemBar() {
		clearInterval(this.moveItemBarId);
		this.itemBarMoving = false;
	}

/** 
* ===========================================================================
* ACTION BOX
* ===========================================================================
**/
	function isActionBoxMoving() {
		return this.actionBoxMoving;
	}

	function moveActionBox() {
		clearInterval(this.moveActionBoxId);
		if(this.actionBoxVisible) {
			if(this.actionBox._x > -114) {
				this.actionBox._x -= 5;
				this.actionBoxMoving = true;
				this.moveActionBoxId = setInterval(this, "moveActionBox", 1);
			} else {
				this.actionBox._x = -114;
				this.actionBoxMoving = false;
				this.actionBoxVisible = false;
			}
		} else {
			if(this.actionBox._x < -4) {
				this.actionBox._x += 5;
				this.actionBoxMoving = true;
				this.moveActionBoxId= setInterval(this, "moveActionBox", 1);
			} else {
				this.actionBox._x = -4;
				this.actionBoxMoving = false;
				this.actionBoxVisible = true;
			}
		}
	}

/** 
* ===========================================================================
* MESSAGE BOX
* ===========================================================================
**/	function isMessageBoxMoving() {
		return this.messageBoxMoving;
	}

	function moveMessageBox() {
		clearInterval(this.moveMessageBoxId);
		if(this.messageBoxVisible) {
			if(this.messageBox._y < 465) {
				this.messageBox._y += 5;
				this.messageBoxMoving = true;
				this.moveMessageBoxId = setInterval(this, "moveMessageBox", 1);
			} else {
				this.messageBox._y = 465;
				this.messageBoxMoving = false;
				this.messageBoxVisible = false;
			}
		} else {
			if(this.messageBox._y > 264) {
				this.messageBox._y -= 5;
				this.messageBoxMoving = true;
				this.moveMessageBoxId = setInterval(this, "moveMessageBox", 1);
			} else {
				this.messageBox._y = 264;
				this.messageBoxMoving = false;
				this.messageBoxVisible = true;
			}
		}
	}
	
	function messageScrolling() {
		return this.messageBoxTextScrolling;
	}
	
	function messageScroll(dir) {
		clearInterval(this.scrollMessageBoxTextId);
		if(dir == 0) {
			this.messageBox.txtMessageBox.scroll++;
		} else {
			this.messageBox.txtMessageBox.scroll--;
		}
		this.messageBoxTextScrolling = true;
		this.scrollMessageBoxTextId = setInterval(this, "messageScroll", 100, dir);
	}
	
	function messageScrollStop() {
		this.messageBoxTextScrolling = false;
		clearInterval(this.scrollMessageBoxTextId);
	}
}