﻿class Inventory {
	var invItems:Vector;
	
	function Inventory() {
		this.invItems = new Vector(10, 10);
	}
	
	function addInventoryItem(invItem:InventoryItem):Void {
		this.invItems.addElement(invItem);
	}
	
	function addInventoryItemAt(invItem:InventoryItem, index:Number) {
		this.invItems.insertElementAt(invItem, index);
	}
	
	function getInventoryItem(index:Number):InventoryItem {
		return this.invItems.get(index);
	}
	
	function getInventoryItemById(id:String):InventoryItem {
		for(var i:Number=0; i<this.invItems.size(); i++) {
			var invItem:InventoryItem = this.invItems.get(i);
			if(invItem.id == id) {
				return invItem;
			}
		}
		return null;
 	}
	
	function getInventoryItems():Vector {
		return this.invItems;
	}
	
	function removeInventoryItem(invItem:InventoryItem):Void {
		this.invItems.removeElement(invItem);
	}

	function removeInventoryItemById(id:String):InventoryItem {
		for(var i:Number=0; i<this.invItems.size(); i++) {
			var invItem:InventoryItem = this.invItems.get(i);
			if(invItem.id == id) {
				this.invItems.removeElement(invItem);
				break;
			}
		}
		return null;
 	}
	
	function replaceInventoryItem(oldItem:InventoryItem, newItem:InventoryItem) {
		for(var i:Number = 0; i<this.invItems.size(); i++) {
			if(this.invItems.get(i) == oldItem) {
				this.invItems.setElementAt(newItem, i)
				break;
			}
		}
	}
	
	function setup():Void {
		this.clear();
		for (var i = 0; i<this.invItems.size(); i++) {
			var invItem:InventoryItem = invItems.get(i);
			invItem.itemMCImage = createMovieClip(invItem, i);
		}
	}
	
	function createMovieClip(invItem:InventoryItem, depth:Number):MovieClip {
		var inventory = this;
		var newItem = _root.itemBar.createEmptyMovieClip(invItem.id, depth);
		var newGraphic = newItem.createEmptyMovieClip(invItem.id+depth+"_tmp", newItem.getNextHighestDepth());
		newGraphic.loadMovie(invItem.picture);
		newItem.invItem = invItem;
		newItem.onRelease = function() {
			inventory.onItemRelease(newItem.invItem);
		};
		newItem.onRollOver = function() {
			inventory.onItemRollOver(newItem.invItem);
		};
		newItem.onRollOut = function() {
			inventory.onItemRollOut(newItem.invItem);
		};
		newItem._alpha = 75;
		newItem._y = 0;
		newItem._x = depth*80+5;
		newItem.useHandCursor = false;
		return newItem;
	}
	
	function clear():Void {
		for (var i = 0; i<invItems.size(); i++) {
			var obj:InventoryItem = invItems.elementAt(i);
			obj.itemMCImage.removeMovieClip();
		}
	}
	
	function onItemRelease(invItem:InventoryItem) {
		var eventTodo:String;
		if(_global.gameMouse.isPickingUp) {
			eventTodo = invItem.eventPickUp;
		} else if (_global.gameMouse.isReady) {
			eventTodo = invItem.eventClick;
		} else if (_global.gameMouse.isUsingWith) {
			eventTodo = invItem.eventUseWith;
		} else if (_global.gameMouse.isUsing) {
			eventTodo = invItem.eventUse;
		} else if (_global.gameMouse.isOpening) {
			eventTodo = invItem.eventOpen;
		} else if (_global.gameMouse.isClosing) {
			eventTodo = invItem.eventClose;
		}
		
		var eHandler:EventHandler = new EventHandler();
		eHandler.handleEvent(eventTodo, invItem);
	}
	
	function onItemRollOver(invItem:InventoryItem):Void {
		invItem.itemMCImage._alpha = 100;
		_root.txtInfoBox.text = invItem.name;
	}
	
	function onItemRollOut(invItem:InventoryItem):Void {
		invItem.itemMCImage._alpha = 75;
		_root.txtInfoBox.text = "";
	}
}
