﻿class Location {
	var name:String;
	var id:String;
	var description:String;
	var visible:Boolean = false;
	var locationLoaded:Boolean = false;
	var locationComplete:Function;

	/*
	var locationXML:XML;
	var hitBoxesXML:XML;
	var worldItemsXML:XML;
	*/
	var eventsXML:XML;
	
	var hitBoxes:Vector;
	var hitBoxesLoaded:Boolean = false;
	var hitBoxesComplete:Function;
	
	var worldItems:Vector;
	var worldItemsLoaded:Boolean = false;
	var worldItemsComplete:Function;
	var worldItemsCompleteCounter:Number;

	var backgroundComplete:Function;
	var backgroundPicture:String;
	var backgroundLoaded:Boolean = false;
	
	function Location(id:String, name:String, description:String) {
		this.id = id;
		this.name = name;
		this.description = description;
		this.hitBoxes = new Vector(10, 10);
		this.worldItems = new Vector(10, 10);
	}
	
/** 
* ===========================================================================
* WORLD ITEMS
* ===========================================================================
**/
	function addWorldItem(wItem:WorldItem):Void {
		this.worldItems.addElement(wItem);
	}
	
	function getWorldItemById(id:String):WorldItem {
		for(var i:Number = 0; i<this.worldItems.size(); i++) {
			var wItem = this.worldItems.get(i)
			if(wItem.id == id) {
				return wItem;
			}
		}
		return null;
	}
	
	function removeHitBox(id:String):Void {
		for(var i:Number = 0; i<this.hitBoxes.size(); i++) {
			var hBox = this.hitBoxes.get(i)
			if(hBox.id == id) {
				hBox.toggleVisibility(false);
				this.hitBoxes.removeElementAt(i);
				break;
			}
		}
	}
	
	function removeWorldItem(id:String):Void {
		for(var i:Number = 0; i<this.worldItems.size(); i++) {
			var wItem = this.worldItems.get(i)
			if(wItem.id == id) {
				wItem.toggleVisibility(false);
				this.worldItems.removeElementAt(i);
				break;
			}
		}
	}
	
	function checkWorldItemsComplete():Void {
		if(this.worldItemsCompleteCounter++ == this.worldItems.size()) {
			this.worldItemsLoaded = true;
			this.worldItemsComplete();
		}
	}
	
	function setUpWorldItems():Void {
		_root.worldItems.removeMovieClip();
		_root.worldItems.unloadMovie();
		_root.worldItems = _root.worldItemsContainer.createEmptyMovieClip("_root.worldItems", 0);
		_root.worldItems._x = 0;
		_root.worldItems._y = 0;
		for(var i:Number = 0;i<this.worldItems.size(); i++) {
			var wItem = this.worldItems.get(i);
			var wItemMC = wItem.itemMC;
			var location = this;
			wItemMC = _root.worldItems.createEmptyMovieClip(wItem.id, i);
			if(!wItem.active) {
				wItemMC.useHandCursor = false;
			}
			wItem.toggleVisibility(wItem.visible);
			wItemMC.reference = this.worldItems.get(i);
			wItemMC.onRelease = function():Void {
				this.reference.onWorldItemRelease();
			}
			wItemMC.onRollOver = function():Void {
				this.reference.onWorldItemRollOver();
			}
			wItemMC.onRollOut = function():Void {
				this.reference.onWorldItemRollOut();
			}

			var my_mcl = new MovieClipLoader();
			var myListener = new Object();
			myListener.wItem = wItem;
			myListener.onLoadInit = function (target_mc):Void {
				target_mc._x = this.wItem.mcX;
				target_mc._y = this.wItem.mcY;
				location.checkWorldItemsComplete();
			} 
			
			wItem.itemMCImage = wItemMC.createEmptyMovieClip(wItem.id+"_tmp", i);
			my_mcl.addListener(myListener);
			my_mcl.loadClip(wItem.picture, wItem.itemMCImage);
		}
	}

/** 
* ===========================================================================
* HITBOXES
* ===========================================================================
**/
	function addHitBox(hBox:HitBox):Void {
		this.hitBoxes.addElement(hBox);
	}
	
	function getHitBoxById(id:String):HitBox {
		for(var i:Number = 0; i<this.hitBoxes.size(); i++) {
			var hBox = this.hitBoxes.get(i)
			if(hBox.id == id) {
				return hBox;
			}
		}
		return null;
	}

	function setUpHitBoxes():Void {
		for(var i:Number = 0;i<this.hitBoxes.size(); i++) {
			var hitBox = this.hitBoxes.get(i);
			var hitBoxMC = hitBox.hitBoxMC;
			var location = this;
			hitBoxMC = _root.hitBoxes.createEmptyMovieClip(hitBox.id, i);
			hitBox.toggleVisibility(hitBox.visible);
			hitBoxMC.reference = this.hitBoxes.get(i);;
			hitBoxMC.onRelease = function():Void {
				this.reference.onHitBoxRelease();
			}
			hitBoxMC.onRollOver = function():Void {
				this.reference.onHitBoxRollOver();
			}
			hitBoxMC.onRollOut = function():Void {
				this.reference.onHitBoxRollOut();
			}
			
			var tmpBox:MovieClip = hitBoxMC.createEmptyMovieClip(hitBox.id+"_tmp", i);
			with (tmpBox) {
				trackAsMenu = true;
				beginFill(0xFF00FF, 0);
				moveTo(0,0);
				lineTo(hitBox.mcWidth,0);
				lineTo(hitBox.mcWidth,hitBox.mcHeight);
				lineTo(0,hitBox.mcHeight);
				endFill();
				_x = hitBox.mcX;
				_y = hitBox.mcY;
			}
			hitBoxMC.trackAsMenu = true;
		}
		location.hitBoxesLoaded = true;
		location.hitBoxesComplete();
	}

	function onHitBoxRelease(hitBox:HitBox):Void {
		hitBox.onHitBoxRelease;
	}

	function onHitBoxRollOver(hitBox:HitBox):Void {
		_global.gameInfoBox.text = hitBox.name;
	}

	function onHitBoxRollOut(hitBox:HitBox):Void {
		hitBox.onHitBoxRollOut;
	}	
	
/** 
* ===========================================================================
* BACKGROUND
* ===========================================================================
**/
	function setBackground(file:String) {
		this.backgroundPicture = file;
	}

	function setUpBackground():Void {
		var my_mcl = new MovieClipLoader();
		var myListener = new Object();
		var location = this;
		myListener.onLoadInit = function (target_mc):Void {
			target_mc._x = 0;
			target_mc._y = 0;
			if(target_mc._height > 400) {
				target_mc._y = (-(target_mc._height - 400) / 2) + 80;
			}
			if(target_mc._width > 640) {
				target_mc._x = -(target_mc._width - 640) / 2;
			}
			_root.hitBoxes._x = target_mc._x;
			_root.hitBoxes._y = target_mc._y;
			_root.worldItems._y = target_mc._y;
			_root.worldItems._x = target_mc._x;
			
			_root.background.useHandCursor = false;
			_root.background.onRelease = function():Void {
				location.onBackgroundRelease();
			}
			
			location.backgroundLoaded = true;
			location.backgroundComplete();
		} 
		
		my_mcl.addListener(myListener);
		my_mcl.loadClip(this.backgroundPicture, _root.background);
	}
	
	function onBackgroundRelease():Void {
		_global.gameMouse.ready();
	}

/** 
* ===========================================================================
* XML STUFF
* ===========================================================================
**/	
	function getLocationEventAsXML(event:String):XML {
		for(var i:Number=0; i<this.eventsXML.childNodes.length; i++) {
			if(this.eventsXML.childNodes[i].nodeName == event) {
				return this.eventsXML.childNodes[i];
			} 
		}
		return null;
	}
}