﻿class MouseAction {
	
	var draggingItem:InventoryItem;
	var draggingItemIndex:Number;
	var usingItem:WorldItem;
	
	var isReady:Boolean = true;
	var isPickingUp:Boolean = false;
	var isScrolling:Boolean = false;
	var isLookingAt:Boolean = false;
	var isOpening:Boolean = false;
	var isClosing:Boolean = false;
	var isUsing:Boolean = false;
	var isUsingWith:Boolean = false;
	var isDragging:Boolean = false;
	
	function ready():Void {
		this.usingItem = undefined;
		this.draggingItem = undefined;
		_global.gameInterface.stopDragging();
		this.isReady = true;
		this.isPickingUp = false;
		this.isScrolling = false;
		this.isLookingAt = false;
		this.isOpening = false;
		this.isClosing = false;
		this.isUsing = false;
		this.isUsingWith = false;
		this.isDragging = false;
	}

	function pickUp():Void {
		this.isReady = false;
		this.isPickingUp = true;
		this.isScrolling = false;
		this.isLookingAt = false;
		this.isOpening = false;
		this.isClosing = false;
		this.isUsing = false;
		this.isUsingWith = false;
		this.isDragging = false;
	}
	
	function scroll():Void {
		this.isReady = false;
		this.isPickingUp = false;
		this.isScrolling = true;
		this.isLookingAt = false;
		this.isOpening = false;
		this.isClosing = false;
		this.isUsing = false;
		this.isUsingWith = false;
		this.isDragging = false;
	}
	
	function lookAt():Void {
		this.isReady = false;
		this.isPickingUp = false;
		this.isScrolling = false;
		this.isLookingAt = true;
		this.isOpening = false;
		this.isClosing = false;
		this.isUsing = false;
		this.isUsingWith = false;
		this.isDragging = false;
	}
	
	function open():Void {
		this.isReady = false;
		this.isPickingUp = false;
		this.isScrolling = false;
		this.isLookingAt = false;
		this.isOpening = true;
		this.isClosing = false;
		this.isUsing = false;
		this.isUsingWith = false;
		this.isDragging = false;		
	}

	function close():Void {
		this.isReady = false;
		this.isPickingUp = false;
		this.isScrolling = false;
		this.isLookingAt = false;
		this.isOpening = false;
		this.isClosing = true;
		this.isUsing = false;
		this.isUsingWith = false;
		this.isDragging = false;		
	}
	
	function use():Void {
		this.isReady = false;
		this.isPickingUp = false;
		this.isScrolling = false;
		this.isLookingAt = false;
		this.isOpening = false;
		this.isClosing = false;
		this.isUsing = true;
		this.isUsingWith = false;
		this.isDragging = false;		
	}
	
	function useWith():Void {
		this.isReady = false;
		this.isPickingUp = false;
		this.isScrolling = false;
		this.isLookingAt = false;
		this.isOpening = false;
		this.isClosing = false;
		this.isUsing = false;
		this.isUsingWith = true;
		this.isDragging = false;		
	}
	
	function drag():Void {
		this.isReady = false;
		this.isPickingUp = false;
		this.isScrolling = false;
		this.isLookingAt = false;
		this.isOpening = false;
		this.isClosing = false;
		this.isUsing = false;
		this.isUsingWith = false;
		this.isDragging = true;		
	}
}