﻿class Vector {
	var m_size:Number;
	var m_capacity:Number;
	var m_increment:Number;
	var m_pData:Array;

	function Vector(initialCapacity, capacityIncrement:Number) {
		m_size = 0;
		m_capacity = initialCapacity;
		m_pData = new Array(m_capacity);
		m_increment = capacityIncrement;
	}

	function capacity():Number {
		return m_capacity;
	}

	function contains(elem):Boolean {
		for (var i = 0; i<m_size; i++) {
			if (m_pData[i] == elem) {
				return true;
			}
		}
		return false;
	}

	function copyInto(array:Array):Void {
		for (var i = 0; i<m_size; i++) {
			array[i] = m_pData[i];
		}
	}

	function elementAt(index:Number) {
		return m_pData[index];
	}
	
	function get(index:Number) {
		return m_pData[index];
	}

	function indexOf(elem):Number {
		for (var i = 0; i<m_size; i++) {
			if (m_pData[i] == elem) {
				return i;
			}
		}
		return -1;
	}

	function isEmpty():Boolean {
		return m_size == 0;
	}

	function lastIndexOf(elem):Number {
		if (m_size == 0) {
			return -1;
		}
		var i = m_size;
		do {
			i -= 1;
			if (m_pData[i] == elem) {
				return i;
			}
		} while (i != 0);
		return -1;
	}

	function size():Number {
		return m_size;
	}

	function addElement(obj) {
		if (m_size == m_capacity) {
			ensureCapacity(m_capacity+m_increment);
		}
		m_pData[m_size++] = obj;
		
	}

	function ensureCapacity(minCapacity:Number):Void {
		if (minCapacity>m_capacity) {
			var i;
			m_capacity = minCapacity;
			var temp = new Array(m_capacity);

			for (i=0; i<m_size; i++) {
				temp[i] = m_pData[i];
			}
			delete m_pData;
			m_pData = temp;
		}
	}

	function insertElementAt(obj, index) {
		if (index == m_size) {
			addElement(obj);
		} else {
			verifyIndex(index);
			if (m_size == m_capacity) {
				ensureCapacity(m_capacity+m_increment);
			}
			var newItem = obj;
			var tmp;
			for (var i = index; i<=m_size; i++) {
				tmp = m_pData[i];
				m_pData[i] = newItem;
				if (i != m_size) {
					newItem = tmp;
				} else {
					break;
				}
			}
			m_size++;
		}
	}

	function removeAllElements() {
		for (var i = 0; i<m_size; i++) {
			delete m_pData[i];
		}
		m_size = 0;
	}

	function removeElement(obj) {
		for (var i = 0; i<m_size; i++) {
			if (m_pData[i] == obj) {
				removeElementAt(i);
				return true;
			}
		}
		return false;
	}

	function removeElementAt(index) {
		verifyIndex(index);
		delete m_pData[index];
		for (var i = index+1; i<m_size; i++) {
			m_pData[i-1] = m_pData[i];
		}
		m_pData[i];
		m_size--;
	}

	function setElementAt(obj, index) {
		verifyIndex(index);
		m_pData[index] = obj;
	}

	function verifyIndex(index:Number) {
		if (index>=m_size) {
			trace("Index groesser als Vector!");
		}
	}
}