﻿class WorldItem {
	var name:String;
	var id:String;
	var picture:String;
	var inventoryPicture:String;
	var description:String;
	var location:Location;
	var pickUpPossible:Boolean = true;
	var alreadyPickedUp:Boolean = false;
	var isInInventory:Boolean = false;
	var active:Boolean = true;
	var visible:Boolean = false;
	var isOpen:Boolean = false;
	
	var _isWorldItem:Boolean = true;
	
	var itemMC:MovieClip;
	var itemMCImage:MovieClip;
	var mcX:Number;
	var mcY:Number;
	
	var eventClick:String;
	var eventUse:String;
	var eventUseWith:String;
	var eventPickUp:String;
	var eventOpen:String;
	var eventClose:String;
	var eventLookAt:String;
	
	
	function WorldItem(posX:Number, posY:Number, picture:String, inventoryPicture:String, name:String, id:String, description:String){
		this.mcX = posX;
		this.mcY = posY;
		this.picture = picture;
		this.inventoryPicture = inventoryPicture;
		this.name = name;
		this.id = id;
		this.description = description;
	}
	
	function markAsPickedUp(picked:Boolean):Void {
		this.alreadyPickedUp = (picked != undefined ? picked : true);
	}
	
	function toggleOpen(doOpen:Boolean):Void {
		var wItem = eval("_root.worldItems." + this.id);
		if(doOpen == undefined) {
			doOpen = !wItem.isOpen;
		}
		wItem.isOpen = doOpen;
		this.isOpen = doOpen;
		
	}
	
	function toggleActive(doActive:Boolean):Void {
		var wItem = eval("_root.worldItems." + this.id);
		if(doActive == undefined) {
			doActive = !wItem.active;
		}
		wItem.active = doActive;
		this.active = doActive;
		wItem.itemMC.useHandCursor = wItem.active;
	}
	
	function toggleVisibility(doShow:Boolean):Void {
		var wItem = eval("_root.worldItems." + this.id);
		if(doShow == undefined) {
			doShow = !wItem._visible;
		}
		wItem._visible = doShow;
		wItem.itemMC._visible = doShow;
		wItem.itemMCImage._visible = doShow;
		this.itemMCImage._visible = doShow;
		this.itemMC._visible = doShow;
		this.visible = doShow;
	}
	
	function onWorldItemRelease():Void {
		var eventTodo:String;
		if(_global.gameMouse.isPickingUp) {
			eventTodo = this.eventPickUp;
		} else if (_global.gameMouse.isReady) {
			eventTodo = this.eventClick;
		} else if (_global.gameMouse.isUsingWith) {
			eventTodo = this.eventUseWith;
		} else if (_global.gameMouse.isUsing) {
			eventTodo = this.eventUse;
		} else if (_global.gameMouse.isOpening) {
			eventTodo = this.eventOpen;
		} else if (_global.gameMouse.isClosing) {
			eventTodo = this.eventClose;
		}
		
		var eHandler:EventHandler = new EventHandler();
		eHandler.handleEvent(eventTodo, this);
	}
	
	function onWorldItemRollOver():Void {
		if(this.name != undefined && this.name.length > 0) {
			_global.gameInfoBox.text = this.name;
		}
	}

	function onWorldItemRollOut():Void {
		_global.gameInfoBox.text = "";
	}
}